<?php
namespace Teknisa\EST\Services;

class Cripto {
    function bround($num) {
        if (strpos($num, '.') === false)
            return $num;

        $num = $num;
        $num_arr = explode('.', $num);
        if (empty($num_arr[1])) return $num;
        if($num_arr[1] == 5) {
            if($num_arr[0] % 2) return $num_arr[0]+1;
            else return $num_arr[0];
        } else return round($num);
    }

    public function cripto($stString, $inOffset) {
        $inTamanho = strlen($stString) - 1;
        $inMeioAnt = intval($inTamanho/2);
        $inMeioPos = $this->bround(($inTamanho/2) + 0.1) + 1;

        $stVetor = $stString;

        for($byAux = 0; $byAux <= $inMeioAnt; $byAux++) {
            $chAux = $stVetor[$byAux];
            $stVetor[$byAux] = $stVetor[$byAux*2];
            $stVetor[$byAux*2] = $chAux;
        }

        for($byAux = $inTamanho; $byAux >= $inMeioPos; $byAux--) {
            $chAux = $stVetor[$byAux*2 - ($inTamanho + 1)];
            $stVetor[$byAux*2 - ($inTamanho + 1)] = $stVetor[$byAux];
            $stVetor[$byAux] = $chAux;
        }

        $stString = '';

        for($byAux = 0; $byAux <= $inTamanho; $byAux++) {
            $stString = $stString.(chr(ord($stVetor[$byAux]) + $inOffset));
        }

        return $stString;
    }

    public function unCripto($stString, $inOffset) {
        $inTamanho = strlen($stString) - 1;
        $inMeioAnt = intval($inTamanho/2);
        $inMeioPos = $this->bround(($inTamanho/2) + 0.1) + 1;

        $stVetor = $stString;

        for($byAux = $inMeioPos; $byAux <= $inTamanho; $byAux++) {
            $chAux = $stVetor[intval($byAux*2 - ($inTamanho + 1))];
            $stVetor[intval($byAux*2 - ($inTamanho + 1))] = $stVetor[intval($byAux)];
            $stVetor[intval($byAux)] = $chAux;
        }

        for($byAux = $inMeioAnt; $byAux >= 0; $byAux--) {
            $chAux = $stVetor[$byAux];
            $stVetor[$byAux] = $stVetor[$byAux*2];
            $stVetor[$byAux*2] = $chAux;
        }

        $stString = '';

        for($byAux = 0; $byAux <= $inTamanho; $byAux++) {
            $stString = $stString.(chr(ord($stVetor[$byAux]) - $inOffset));
        }

        return $stString;
    }
}
